<template>
    <div class="app-container">
        <el-form :model="queryParams" ref="queryForm" @submit.native.prevent :inline="true" v-show="showSearch" label-width="68px">
            <el-form-item label-width="120px" prop="orgId">
                <el-select v-model="queryParams.orgId" placeholder="请选择" clearable>
                    <el-option-group label="工厂" v-if="sourceType == '01'">
                        <template>
                            <el-option v-for="factory in factoryList" :key="factory.id + factory.sourceType" :label="factory.name" :value="factory.id"> </el-option>
                        </template>
                    </el-option-group>
                    <el-option-group label="门店" v-if="sourceType == '02'">
                        <template>
                            <el-option v-for="store in storeList" :key="store.id + store.sourceType" :label="store.name" :value="store.id"> </el-option>
                        </template>
                    </el-option-group>
                </el-select>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
                <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <Page uri="/mapi/settlement/rate/list" :request-params="queryParams" ref="pagination">
            <el-table-column label="编号" align="center" prop="id" width="100px" />
            <el-table-column :label="sourceType == '01' ? '工厂名称' : '门店名称'" align="center">
                <template slot-scope="scope">
                    <span v-if="scope.row.orgId == org.id && scope.row.sourceType == org.sourceType" v-for="org in orgList" :key="org.id + org.sourceType">
                        {{ org.name }}
                    </span>
                </template>
            </el-table-column>
            <el-table-column label="工厂结算费率" align="center" prop="factoryRate" v-if="sourceType == '02'" />
            <el-table-column label="材料费率" align="center" prop="materialRate" />
            <el-table-column label="管理费率" align="center" prop="manageRate" />
            <el-table-column label="押金费率" align="center" prop="depositRate" />
            <el-table-column label="云洗费率" align="center" prop="factoryRate" v-if="sourceType == '01'" />
            <el-table-column label="异店消费费率" align="center" prop="otherStoreRate" v-if="sourceType == '02'" />
            <el-table-column label="支付宝费率" align="center" prop="aliPayRate" v-if="sourceType == '02'" />
            <el-table-column label="微信费率" align="center" prop="wxPayRate" v-if="sourceType == '02'" />
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="150">
                <template slot-scope="scope">
                    <el-button type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['settlement:rate:edit']">修改</el-button>
                    <!--          <el-button-->
                    <!--             -->
                    <!--            type="text"-->
                    <!--            icon="el-icon-delete"-->
                    <!--            @click="handleDelete(scope.row)"-->
                    <!--            v-hasPermi="['settlement:rate:remove']"-->
                    <!--          >删除</el-button>-->
                </template>
            </el-table-column>
        </Page>

        <!-- 添加或修改结算费率对话框 -->
        <el-dialog :title="title" :visible.sync="open" size="30%" append-to-body>
            <el-row :gutter="15">
                <el-form ref="form" :model="form" :rules="rules" label-width="130px">
                    <el-col :span="24">
                        <el-form-item :label="sourceType == '02' ? '工厂结算费率' : '云洗费率'" prop="factoryRate">
                            <el-input-number v-model="form.factoryRate" :precision="4" :step="0.001" :max="1" />
                        </el-form-item>
                        <el-form-item label="材料费率" prop="materialRate">
                            <el-input-number v-model="form.materialRate" :precision="4" :step="0.001" :max="1" />
                        </el-form-item>
                        <el-form-item label="管理费率" prop="manageRate">
                            <el-input-number v-model="form.manageRate" :precision="4" :step="0.001" :max="1" />
                        </el-form-item>
                        <el-form-item label="押金费率" prop="depositRate">
                            <el-input-number v-model="form.depositRate" :precision="4" :step="0.001" :max="1" />
                        </el-form-item>
                        <el-form-item label="异店消费费率" prop="otherStoreRate" v-if="sourceType == '02'">
                            <el-input-number v-model="form.otherStoreRate" :precision="4" :step="0.001" :max="1" />
                        </el-form-item>
                        <el-form-item label="支付宝费率" prop="aliPayRate" v-if="sourceType == '02'">
                            <el-input-number v-model="form.aliPayRate" :precision="4" :step="0.01" :max="1" />
                        </el-form-item>
                        <el-form-item label="微信费率" prop="wxPayRate" v-if="sourceType == '02'">
                            <el-input-number v-model="form.wxPayRate" :precision="4" :step="0.01" :max="1" />
                        </el-form-item>
                    </el-col>
                </el-form>
            </el-row>

            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitForm" style="margin-left: 5%">提交</el-button>
                <el-button @click="cancel">取 消</el-button>
            </div>
        </el-dialog>
    </div>
</template>

<script>
import { listRate, getRate, delRate, addRate, updateRate, updateRateStatus } from '@/api/settlement/rate'
import { allOrg } from '@/api/system/store'

export default {
    name: 'Rate',
    data() {
        return {
            orgList: [],
            storeList: [],
            factoryList: [],
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // 结算费率表格数据
            rateList: [],
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            // 查询参数
            queryParams: {
                orgId: null
            },
            // 表单参数
            form: {},
            // 表单校验
            rules: {},
            sourceType: null
        }
    },
    created() {
        this.sourceType = this.getUrlParam('source_type')
        allOrg().then((res) => {
            this.orgList = res.data
            this.orgList.forEach((org) => {
                if (org.sourceType == '01') {
                    this.factoryList.push(org)
                } else {
                    this.storeList.push(org)
                }
            })
        })

        this.getList()
    },
    methods: {
        /** 查询结算费率列表 */
        getList() {
            this.queryParams.sourceType = this.sourceType
            this.$nextTick(() => {
                this.$refs.pagination.handleSearch(true)
            })
        },
        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        // 表单重置
        reset() {
            this.form = {
                id: null,
                sourceType: null,
                orgId: null,
                factoryRate: null,
                materialRate: null,
                manageRate: null,
                depositRate: null,
                otherStoreRate: null,
                wxPayRate: null,
                aliPayRate: null
            }
            this.resetForm('form')
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.getList()
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.resetForm('queryForm')
            this.handleQuery()
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map((item) => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset()
            this.open = true
            this.title = '添加结算费率'
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset()
            const id = row.id || this.ids
            getRate(id).then((response) => {
                this.form = response.data
                this.open = true
                this.title = '修改结算费率'
            })
        },
        /** 提交按钮 */
        submitForm() {
            this.$refs['form'].validate((valid) => {
                if (valid) {
                    if (this.form.id != null) {
                        updateRate(this.form).then((response) => {
                            this.$modal.msgSuccess('修改成功')
                            this.open = false
                            this.getList()
                        })
                    } else {
                        addRate(this.form).then((response) => {
                            this.$modal.msgSuccess('新增成功')
                            this.open = false
                            this.getList()
                        })
                    }
                }
            })
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            const ids = row.id || this.ids
            this.$modal
                .confirm('是否确认删除结算费率编号为"' + ids + '"的数据项？')
                .then(function () {
                    return delRate(ids)
                })
                .then(() => {
                    this.getList()
                    this.$modal.msgSuccess('删除成功')
                })
                .catch(() => {})
        },
        /** 导出按钮操作 */
        handleExport() {
            this.download(
                'mapi/settlement/rate/export',
                {
                    ...this.queryParams
                },
                `rate_${new Date().getTime()}.xlsx`
            )
        },
        checkClose(done) {
            this.$confirm('是否关闭表单，关闭后数据将丢失？')
                .then(function () {
                    done()
                })
                .then(() => {})
                .catch(() => {})
        }
    }
}
</script>
